//+------------------------------------------------------------------+
//|                                                     Ljp_MACD.mq4 |
//|                                Copyright 2011, Jiao LiuDian      |
//|                                              mailto:8jp@sohu.com |
//+------------------------------------------------------------------+
// This is the correct computation and display of MACD.
#property copyright "Copyright 2011 Jiao LiuDian"
#property link      "mailto:8jp@sohu.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Snow
#property indicator_color2 Gold
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 Olive

extern bool NeedAlert=false;
extern bool NeedOrderWarning=false;
extern double HighPrice=99999;
extern double LowPrice=0;
extern string Warning = "";
//---- input parameters
extern int       FastMAPeriod=12;
extern int       SlowMAPeriod=26;
extern int       SignalMAPeriod=9;

//---- buffers
double MACDLineBuffer[];
double SignalLineBuffer[];
double HistogramBuffer1[];
double HistogramBuffer2[];
double HistogramBuffer3[];
//---- variables
string ShortName;
int shouldCreateWarning=1;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   //---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MACDLineBuffer);
   SetIndexDrawBegin(0,SlowMAPeriod);
  
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(1,SignalLineBuffer);
   SetIndexDrawBegin(1,SlowMAPeriod+SignalMAPeriod);
  
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexBuffer(2,HistogramBuffer1);
   SetIndexDrawBegin(2,SlowMAPeriod+SignalMAPeriod);
  
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexBuffer(3,HistogramBuffer2);
   SetIndexDrawBegin(3,SlowMAPeriod+SignalMAPeriod);
  
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexBuffer(4,HistogramBuffer3);
   SetIndexDrawBegin(4,SlowMAPeriod+SignalMAPeriod);

 
   //---- name for DataWindow and indicator subwindow label
   string temp;
   if(NeedOrderWarning) temp="OrderWarningOpened";  else temp="";
   if(NeedAlert)
   {
     ShortName="MACD("+FastMAPeriod+","+SlowMAPeriod+","+SignalMAPeriod+")"
                       +" AlertOpened"+"("+DoubleToStr(LowPrice,1)+"--"+DoubleToStr(HighPrice,1)+") "+temp;
   }
   else
   {
     ShortName="MACD("+FastMAPeriod+","+SlowMAPeriod+","+SignalMAPeriod+")"+" "+temp;
   }
   IndicatorShortName(ShortName);
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"Red");
   SetIndexLabel(3,"Green");
   SetIndexLabel(4,"Extreme");

   shouldCreateWarning=1;
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   //----
   ObjectDelete("Label_Warning");
   //Print("deinit~~~~~~~~~~~~");
   //----
   return(0);
}
int OrderWarning()
{
  static int count=0;
  color Color;
  int FontSize;
  int objNumber=0;
  for(int i=0;i<5;i++)//һʻ5ڣѭĿͷΪʻлʱͬʻһ
  {
      if(ObjectFind("OrderWarning1"+i)!=-1) ObjectDelete("OrderWarning1"+i);
      if(ObjectFind("OrderWarning2"+i)!=-1) ObjectDelete("OrderWarning2"+i);
      if(ObjectFind("OrderWarning3"+i)!=-1) ObjectDelete("OrderWarning3"+i);
  }
  for(int pos=0;pos<OrdersTotal();pos++)
   {
      if(!OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
      {
        Print("OrderSelect error:#",GetLastError());
        continue;
      }
      else
      {
       int PointOfProfit=OrderProfit()/OrderLots();//ƽӮʹƷֵ֣޸
       //Print(PointOfProfit,",",(Close[0]-OrderOpenPrice())*100);//ԣ߼ò50
       //if(pos==1)Print(TimeHour(OrderOpenTime()),":",TimeMinute(OrderOpenTime())); 
       //Print(MarketInfo(Symbol(),MODE_POINT));//ԣƽֵΪ0.01Ϊ0.001 
       //Print(MarketInfo(Symbol(),MODE_SPREAD));//ԣƽֵΪ50Ϊ30
       int SpreadValueInPoints=MarketInfo(Symbol(),MODE_SPREAD);
       double MaxPrice=0,MinPrice=99999999;
       int DuringTime=0;
       //Ӷµʼڵ߼ۺͼ
       for(i=0; i<Bars; i++)
          { 
            //if(pos==0 && i<=1)Print(OrderOpenTime(),"-",Time[i]);
           
            if(iHigh(NULL,PERIOD_M1,i)>MaxPrice) {MaxPrice=iHigh(NULL,PERIOD_M1,i);}
            if(iLow(NULL,PERIOD_M1,i)<MinPrice) {MinPrice=iLow(NULL,PERIOD_M1,i);}
           // if(pos==1&& i>35) Print(i);
            if(OrderOpenTime()-iTime(NULL,PERIOD_M1,i)>=0)//ʱΪλ
            {
              break;
            }
          }
         //if(pos==0) Print(MinPrice,"-",MaxPrice);
         //Print(i);
         DuringTime=i;
         //Print("DuringTime:",DuringTime); 
       switch(count)
        {
           case 0:
                Color=Yellow;
                FontSize=20;
                break;
           case 1:
                Color=LawnGreen;
                FontSize=20;
                break;
           case 2:
                Color=Red;
                FontSize=20;
                break;
           default:
                break;
         }
       bool HasProfit=false,Need50Percent=false,NeedBalance=false; 
       double MaxProfit=0;//Ϊ
       if(PointOfProfit>0) HasProfit=true;
       if(OrderType()==OP_BUY)
        {
          MaxProfit=(MaxPrice-OrderOpenPrice())*100;//Ӯ򱨼۾ƽּۡ۳
          if(MaxProfit>=200) //Ӯ200ϲʹ50%Ӯ
          {
            if(PointOfProfit<MaxProfit/2) Need50Percent=true;
          }
          else if(MaxProfit>=100)//Ӯ100ʹӮƽֹ
          {
             if(PointOfProfit<0) NeedBalance=true;
          }
          //if(pos==2)Print(MaxPrice,"-",OrderOpenPrice()," ",MaxPrice-OrderOpenPrice());
          //Print(OrderOpenPrice());
        }
        else if(OrderType()==OP_SELL)
        {
          MaxProfit=(OrderOpenPrice()-MinPrice)*100-SpreadValueInPoints;//Ӯ۳
          if(MaxProfit>=200) //Ӯ200ϲʹ50%Ӯ
          {
            if(PointOfProfit<MaxProfit/2) Need50Percent=true;
          }
          else if(MaxProfit>=100)//Ӯ100ʹӮƽֹ
          {
             if(PointOfProfit<0) NeedBalance=true;
          }
        } 
        else//ҵ
        {
          continue;
        }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       //ʱֹ
       if(DuringTime>25 && !HasProfit)
        {
          if(!ObjectCreate("OrderWarning1"+pos, OBJ_LABEL, 0, 0, 0))
           {
              Print("error: cannot create OrderWarning1 object! code #",GetLastError());
           }
           else
           {
             ObjectSet("OrderWarning1"+pos, OBJPROP_XDISTANCE, 100);
             ObjectSet("OrderWarning1"+pos, OBJPROP_YDISTANCE, 10+objNumber*30);
             ObjectSetText("OrderWarning1"+pos, "("+pos+")"+"Ӯ:"+PointOfProfit+"(Max:"+DoubleToStr(MaxProfit,0)+")"
                            +"~~~ʱֹ:"+DuringTime+"ӣ", FontSize,"΢ź",Color);
             PlaySound("expert.wav");
             objNumber++;
           }
        }
 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
        //50%ֹӮ
        if(Need50Percent)
        {
          if(!ObjectCreate("OrderWarning2"+pos, OBJ_LABEL, 0, 0, 0))
           {
              Print("error: cannot create OrderWarning2 object! code #",GetLastError());
           }
           else
           {
             ObjectSet("OrderWarning2"+pos, OBJPROP_XDISTANCE, 100);
             ObjectSet("OrderWarning2"+pos, OBJPROP_YDISTANCE, 10+objNumber*30);
             ObjectSetText("OrderWarning2"+pos, "("+pos+")"+"Ӯ:"+PointOfProfit+"(Max:"+DoubleToStr(MaxProfit,0)+")"
                             +"~~~50%ֹӮ",FontSize,"΢ź",Color);
             PlaySound("expert.wav");
             objNumber++;
           }
        }
 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
         //Ӯƽֹ
         if(NeedBalance)
         {
          if(!ObjectCreate("OrderWarning3"+pos, OBJ_LABEL, 0, 0, 0))
           {
              Print("error: cannot create OrderWarning3 object! code #",GetLastError());
           }
           else
           {
             ObjectSet("OrderWarning3"+pos, OBJPROP_XDISTANCE, 100);
             ObjectSet("OrderWarning3"+pos, OBJPROP_YDISTANCE, 10+objNumber*30);
             ObjectSetText("OrderWarning3"+pos, "("+pos+")"+"Ӯ:"+PointOfProfit+"(Max:"+DoubleToStr(MaxProfit,0)+")"
                           +"~~~Ӯƽֹ", FontSize,"΢ź",Color);
             PlaySound("expert.wav");
             objNumber++;
           }
         }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
      }
    }
    count=(count+1)%3;
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  // if(Period()==PERIOD_M1 || Period()==PERIOD_M5)
  if(NeedOrderWarning)
   {
      OrderWarning();
   }
  //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   int limit;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) {Print(counted_bars); return(-1);}
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;
   if (NeedAlert)
   {
       if(   (Close[0]>HighPrice && Close[1]<=HighPrice)
           ||(Close[0]>HighPrice && Close[1]>HighPrice && Close[2]<=HighPrice)
           ||(Close[0]<LowPrice && Close[1]>=LowPrice)
           ||(Close[0]<LowPrice && Close[1]<LowPrice && Close[2]>=LowPrice)
         )
          {
             //Alert("",LowPrice,"-",HighPrice,"ͻ");
             PlaySound("expert.wav");
             //PlaySound("alert.wav");
          }
   }
  
   if(shouldCreateWarning==1 && Warning!="") //ָ괰ڴϢ
   {
     int indexofWindow=WindowFind(ShortName);
     if(!ObjectCreate("Label_Warning", OBJ_LABEL,indexofWindow,0,0))
      {
         Print("error: cannot create Label_object! code #",GetLastError());
         Print("WindowIndex=",indexofWindow);
         if(GetLastError()==4200) shouldCreateWarning=0;//Ѵ
      }
      else
      {
        shouldCreateWarning=0;
      }
      ObjectSet("Label_Warning",OBJPROP_XDISTANCE, 368);
      ObjectSet("Label_Warning",OBJPROP_YDISTANCE, 0);
      //ObjectSet("Label_Warning",OBJPROP_STYLE, STYLE_DOT);
      ObjectSetText("Label_Warning",Warning, 12, "Times New Roman",C'255,0,0');
    }
   int FangDaBeiShu=2;
   for(int i=limit; i>=0; i--)
   {
      HistogramBuffer1[i]=0;
      HistogramBuffer2[i]=0;
      HistogramBuffer3[i]=0;
      MACDLineBuffer[i] =   iMACD(NULL,0,FastMAPeriod,SlowMAPeriod,SignalMAPeriod,PRICE_CLOSE,MODE_MAIN,i);
      SignalLineBuffer[i] = iMACD(NULL,0,FastMAPeriod,SlowMAPeriod,SignalMAPeriod,PRICE_CLOSE,MODE_SIGNAL,i);
       if(MACDLineBuffer[i] - SignalLineBuffer[i]>0)
      {
          HistogramBuffer1[i] = (MACDLineBuffer[i] - SignalLineBuffer[i])*FangDaBeiShu;
      }
      else
      {
          HistogramBuffer2[i] = (MACDLineBuffer[i] - SignalLineBuffer[i])*FangDaBeiShu;
      }
     
   }
   return(0);
}
//+------------------------------------------------------------------+